package dk.aau.cs.io;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import pipe.dataLayer.NetType;


import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.*;

public class CheckFileNetType {

    public static NetType checkFileNetType(File file) {
        InputStream stream = makeInputStream(file);
        Document doc = loadDocument(stream);
        Node pnmlElement = doc.getElementsByTagName("pnml").item(0);
        Node netNode = getFirstDirectChild(pnmlElement, "net");
        boolean isColored = (getFirstDirectChild(netNode, "declaration") != null);
        if (isColored != true) {
            return NetType.TAPN;
        }
        else
            return NetType.CPN;
    }

    public static NetType checkFileNetType(InputStream file) {
        Document doc = loadDocument(file);
        Node pnmlElement = doc.getElementsByTagName("pnml").item(0);
        Node netNode = getFirstDirectChild(pnmlElement, "net");
        boolean isColored = (getFirstDirectChild(pnmlElement, "declaration") != null);
        if (isColored != true) {
            return NetType.TAPN;
        }
        else
            return NetType.CPN;
    }


    private static Node getFirstDirectChild(Node parent, String tagName) { {
            NodeList children = parent.getChildNodes();
            for(int i = 0; i < children.getLength(); i++){
                if(children.item(i).getNodeName().equals(tagName)){
                    return children.item(i);
                }
            }
            return null;
        }
    }

    private static Document loadDocument(InputStream file) {
        try {
            DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            return builder.parse(file);
        } catch (ParserConfigurationException e) {
            return null;
        } catch (SAXException e) {
            return null;
        } catch (IOException e) {
            return null;
        }
    }

    private static InputStream makeInputStream(File file) {
        try {
            return new FileInputStream(file);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }
}
