package dk.aau.cs.model.tapn.Colored.Expressions;

import dk.aau.cs.model.tapn.Colored.Color;
import dk.aau.cs.model.tapn.Colored.ColorType;
import dk.aau.cs.model.tapn.Colored.ExpressionSupport.ExprStringPosition;
import dk.aau.cs.model.tapn.Colored.ExpressionSupport.ExprValues;
import dk.aau.cs.model.tapn.Colored.Variable;

import java.util.Set;
import java.util.Vector;

public class AllExpression extends Expression {

    private ColorType sort;

    public ColorType getColorType(){
        return this.sort;
    }

    public AllExpression(ColorType sort) {
        this.sort = sort;
    }

    public ColorType eval(ExpressionContext context) {
        return sort;
    }

    public Integer size() {
        return sort.size();
    }

    @Override
    public AllExpression replace(Expression object1, Expression object2) {
        if (this == object1 && object2 instanceof AllExpression) {
            AllExpression obj2 = (AllExpression) object2;
            obj2.setParent(parent);
            return obj2;
        } else {
            return this;
        }
    }

    public ColorType getSort() {return sort;}

    @Override
    public AllExpression copy() {
        return new AllExpression(sort);
    }

    @Override
    public boolean containsPlaceHolder() {
        return false;
    }

    @Override
    public AllExpression findFirstPlaceHolder() {
        return null;
    }

    @Override
    public ExprValues getValues(ExprValues exprValues) {
        exprValues.addColorType(sort);
        return exprValues;
    }

    @Override
    public void getVariables(Set<Variable> variables) {

    }

    public String toString() {
        return sort.getName() + ".all";
    }

    @Override
    public boolean isSimpleProperty() {return false; }

    @Override
    public ExprStringPosition[] getChildren() {
        ExprStringPosition[] children = new ExprStringPosition[0];
        return children;
    }

    @Override
    public boolean equals(Object o) {
        if (o instanceof AllExpression) {
            AllExpression expr = (AllExpression) o;
            return expr.sort.equals(this.sort);
        }
        return false;
    }
}
