package dk.aau.cs.model.tapn.Colored;

import dk.aau.cs.model.tapn.AbstractTimeConstraint;
import dk.aau.cs.model.tapn.LocalTimedPlace;
import dk.aau.cs.util.Require;

import java.util.ArrayList;
import java.util.List;

public class LocalColoredPlace extends LocalTimedPlace {

    private ColorType colorType;
    private List<ColoredTimeInvariant> ctiList = new ArrayList<ColoredTimeInvariant>() {{
       add(ColoredTimeInvariant.LESS_THAN_INFINITY_DYN_COLOR(Color.STAR_COLOR));
    }};

    public LocalColoredPlace(String name, ColorType colorType) {
        super(name);
        this.colorType = colorType;
    }

    public List<ColoredTimeInvariant> getCtiList() {
        return ctiList;
    }

    public void setCtiList(List<ColoredTimeInvariant> ctiList) {
        List<ColoredTimeInvariant> found = new ArrayList<ColoredTimeInvariant>();
        for (ColoredTimeInvariant timeInvariant : ctiList) {
            if (timeInvariant == null)
                found.add(timeInvariant);
        }
        ctiList.removeAll(found);
        this.ctiList = ctiList;
    }

    public LocalColoredPlace(String name) {
        super(name);
    }

    public void setColorType(ColorType colorType) {
        this.colorType = colorType;
    }

    public ColorType getColorType() {return colorType;}
}