package pipe.gui.graphicElements.cpn;

import dk.aau.cs.gui.Context;
import dk.aau.cs.model.tapn.Colored.ColoredOutputArc;
import dk.aau.cs.model.tapn.Colored.Expressions.ArcExpression;
import pipe.gui.CreateGui;
import pipe.gui.graphicElements.PlaceTransitionObject;
import pipe.gui.graphicElements.tapn.TimedOutputArcComponent;
import pipe.gui.widgets.cpn.ColoredArcDialogPanel;
import pipe.gui.widgets.EscapableDialog;

import javax.swing.*;
import java.awt.*;

public class ColoredOutputArcComponent extends TimedOutputArcComponent {

    ArcExpression expression;

    public ColoredOutputArcComponent(double startPositionXInput,
                                     double startPositionYInput, double endPositionXInput,
                                     double endPositionYInput, PlaceTransitionObject sourceInput,
                                     PlaceTransitionObject targetInput, int weightInput, ArcExpression expressionInput, String idInput,
                                     boolean taggedInput) {
        super(startPositionXInput, startPositionYInput, endPositionXInput, endPositionYInput, sourceInput, targetInput, weightInput, idInput, taggedInput);
        expression = expressionInput;
    }

    public ColoredOutputArcComponent(TimedOutputArcComponent arc, ArcExpression expressionInput) {
        super(arc);
        expression = expressionInput;
    }

    public ColoredOutputArcComponent(PlaceTransitionObject newSource, ArcExpression expressionInput) {
        super(newSource);
        expression = expressionInput;
    }

    public ColoredOutputArcComponent(ColoredOutputArcComponent arc) {
        super(arc);
        expression = arc.getExpression();
    }


    @Override
    public void updateLabel(boolean displayConstantNames) {
        if (underlyingArc() != null) {
            if (((ColoredOutputArc)underlyingArc()).getExpression() != null) {
                label.setText(getWeight().toString(displayConstantNames) +
                        "\n" + ((ColoredOutputArc)underlyingArc()).getExpression().toString());
                setLabelPosition();
            }

        } else {
            label.setText("");
            label.setText(getWeight().toString(displayConstantNames)+" " + label.getText());
            setLabelPosition();
        }
    }

    @SuppressWarnings("Duplicates")
    @Override
    public void showTimeIntervalEditor() {
        EscapableDialog guiDialog = new EscapableDialog(CreateGui.getApp(), "Edit Arc", true);

        Container contentPane = guiDialog.getContentPane();

        // 1 Set layout
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));

        // 2 Add Place editor
        contentPane.add(new ColoredArcDialogPanel(guiDialog.getRootPane(), this, new Context(CreateGui.getCurrentTab())));

        guiDialog.setResizable(false);

        // Make window fit contents' preferred size
        guiDialog.pack();

        // Move window to the middle of the screen
        guiDialog.setLocationRelativeTo(null);
        guiDialog.setVisible(true);

    }

    public ColoredOutputArcComponent(PlaceTransitionObject newSource) {
        super(newSource);
    }

    public ArcExpression getExpression() {
        return expression;
    }
}