package pipe.gui.graphicElements.cpn;

import dk.aau.cs.gui.Context;
import dk.aau.cs.model.tapn.Colored.ColoredTransition;
import pipe.gui.CreateGui;
import pipe.gui.graphicElements.tapn.TimedTransitionComponent;
import pipe.gui.widgets.cpn.ColoredTransitionEditorPanel;
import pipe.gui.widgets.EscapableDialog;

import javax.swing.*;
import java.awt.*;

public class ColoredTransitionComponent extends TimedTransitionComponent {

    public ColoredTransitionComponent(double positionXInput, double positionYInput, String idInput, String nameInput,
                                      double nameOffsetXInput, double nameOffsetYInput, boolean timedTransition,
                                      boolean infServer, int angleInput, int priority) {
        super(positionXInput, positionYInput, idInput, nameInput, nameOffsetXInput, nameOffsetYInput, timedTransition,
                infServer, angleInput, priority);
    }

    public ColoredTransitionComponent(double positionX, double positionY, ColoredTransition ct) {
        super(positionX, positionY, ct);
        init();
    }

    private void init(){
        pnName.setText("true");
        update(true);
    }

    @Override
    public void update(boolean displayConstantNames) {

        if(transition != null ) {
            pnName.setName(transition.name());
            pnName.setVisible(attributesVisible);
            pnName.zoomUpdate(zoom);

            if(((ColoredTransition)this.underlyingTransition()).getGuard() != null) {
                pnName.setText("");
                super.update(displayConstantNames);
                pnName.setText(pnName.getText() + "\n" + ((ColoredTransition)this.underlyingTransition()).getGuard().toString());
            }
            else {
                pnName.setText("");
                super.update(displayConstantNames);
                pnName.setText(pnName.getText() + "");
            }
        }


        repaint();
    }

    @Override
    public void showEditor() {
        ColoredTransition ct = (ColoredTransition)this.underlyingTransition();
        EscapableDialog guiDialog = new EscapableDialog(CreateGui.getApp(),
                "Edit Transition", true);

        Container contentPane = guiDialog.getContentPane();

        // 1 Set layout
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));

        // 2 Add Place editor
        if (ct.getGuard() != null) {
            contentPane.add(new ColoredTransitionEditorPanel(guiDialog.getRootPane(), this, new Context(CreateGui.getCurrentTab())), ct.getGuard());
        }
        else {
            contentPane.add(new ColoredTransitionEditorPanel(guiDialog.getRootPane(), this, new Context(CreateGui.getCurrentTab())));
        }


        guiDialog.setResizable(true);

        // Make window fit contents' preferred size
        guiDialog.pack();

        // Move window to the middle of the screen
        guiDialog.setLocationRelativeTo(null);
        guiDialog.setVisible(true);
    }
}