package pipe.gui.graphicElements.cpn;

import dk.aau.cs.gui.Context;
import dk.aau.cs.model.tapn.Colored.Color;
import dk.aau.cs.model.tapn.Colored.ColoredTimeInterval;
import dk.aau.cs.model.tapn.Colored.ColoredTransportArc;
import dk.aau.cs.model.tapn.Colored.Expressions.ArcExpression;
import pipe.gui.CreateGui;
import pipe.gui.graphicElements.PlaceTransitionObject;
import pipe.gui.graphicElements.tapn.TimedInputArcComponent;
import pipe.gui.graphicElements.tapn.TimedTransportArcComponent;
import pipe.gui.widgets.EscapableDialog;
import pipe.gui.widgets.cpn.ColoredArcDialogPanel;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class ColoredTransportArcComponent extends TimedTransportArcComponent {

    public ColoredTransportArcComponent(PlaceTransitionObject newSource, int groupNr, boolean isInPreSet) {
        super(newSource, groupNr, isInPreSet);
    }

    public ColoredTransportArcComponent(TimedInputArcComponent timedArc, int group,
                                      boolean isInPreSet) {
        super(timedArc, group, isInPreSet);
        this.setGroup(group);
        // hack to reprint the label of the arc
        updateLabel(true);
    }

    @Override
    public void updateLabel(boolean displayConstantNames) {
        String labelText = "";
        if (isInPreSet() && underlyingTransportArc() != null) {
            if (((ColoredTransportArc)underlyingTransportArc()).getExpression() != null)
                labelText += ((ColoredTransportArc)underlyingTransportArc()).getExpression().toString() + "\n";

            List<ColoredTimeInterval> ctiList = ((ColoredTransportArc)underlyingTransportArc()).getCtiList();
            for (ColoredTimeInterval timeInterval : ctiList) {
                if (timeInterval != null)
                    labelText += timeInterval.toString() + "\n";
            }
            label.setText(labelText);
        }
        else if (!isInPreSet() && underlyingTransportArc() != null) {
            if (((ColoredTransportArc)underlyingTransportArc()).getExpression() != null)
                labelText += ((ColoredTransportArc)underlyingTransportArc()).getExpression().toString() + "\n";
            label.setText(labelText);
        }

    }
    
    
    @Override
    public void showTimeIntervalEditor() {
        EscapableDialog guiDialog = new EscapableDialog(CreateGui.getApp(), "Edit Transport Arc", true);

        Container contentPane = guiDialog.getContentPane();

        // 1 Set layout
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));
        ColoredArcDialogPanel panel = new ColoredArcDialogPanel(guiDialog.getRootPane(), this, new Context(CreateGui.getCurrentTab()));
        JScrollPane scrollPane = new JScrollPane(panel);
        scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        contentPane.add(scrollPane);

        guiDialog.setResizable(true);

        // Make window fit contents' preferred size
        guiDialog.pack();

        // Move window to the middle of the screen
        guiDialog.setLocationRelativeTo(null);
        guiDialog.setVisible(true);
    }
}
